use cgmath::{vec2, vec3, Vector2, Vector3, Zero};

use crate::triangle::Triangle;

use std::f32::MAX;

pub struct Intersection {
    pub distance: f32,
    pub triangle: Triangle,
    pub barycentric: Vector2<f32>,
}

impl Intersection {
    pub fn new(distance: f32, triangle: Triangle, barycentric: Vector2<f32>) -> Intersection {
        Intersection {
            distance,
            triangle,
            barycentric,
        }
    }

    pub fn zero() -> Intersection {
        Intersection {
            distance: MAX,
            triangle: Triangle::zero(),
            barycentric: Vector2::zero(),
        }
    }
}
